%bcond_without bpf

Summary:        Utilities for video4linux and DVB devices
Name:           v4l-utils
Version:        1.24.1
Release:        4%{?dist}
License:        GPLv2+ and GPLv2
URL:            http://www.linuxtv.org/downloads/v4l-utils/

Source0:        http://linuxtv.org/downloads/v4l-utils/v4l-utils-%{version}.tar.bz2
Patch3000:      0001-utils-v4l2-TPG-Update-use-of-typeof.patch

BuildRequires:  alsa-lib-devel make gcc-c++
BuildRequires:  libjpeg-devel gettext doxygen
BuildRequires:  systemd-devel systemd kernel-headers qt5-qtbase-devel

%if %{with bpf}
BuildRequires:  elfutils-libelf-devel clang
%endif

Requires:       systemd-udev
Requires:       libv4l = %{version}-%{release}

%description
v4l-utils is a collection of various video4linux (V4L) and DVB utilities. The
main v4l-utils package contains cx18-ctl, ir-keytable, ivtv-ctl, v4l2-ctl and
v4l2-sysfs-path.

%package        devel-tools
Summary:        Utilities for v4l2 / DVB driver development and debugging
License:        GPLv2+ and GPLv2
Requires:       libv4l = %{version}-%{release}

%description    devel-tools
This package provides decode_tm6000, v4l2-compliance and v4l2-dbg.

%package -n     qv4l2
Summary:        QT v4l2 test control and streaming test application
License:        GPLv2+
Requires:       libv4l%{?_isa} = %{version}-%{release}

%description -n qv4l2
QT v4l2 test control and streaming test application.

%package -n     libv4l
Summary:        Collection of video4linux support libraries 
License:        LGPLv2+ and GPLv2
URL:            http://hansdegoede.livejournal.com/3636.html

%description -n libv4l
This package provides libraries for developers of %{name}.

%package -n     libdvbv5
Summary:        Libraries to control, scan and zap on Digital TV channels
License:        GPLv2

%description -n libdvbv5
This package provides libraries to control, scan and zap on Digital TV channels


%package -n     libv4l-devel
Summary:        Development files for libv4l
License:        LGPLv2+
URL:            http://hansdegoede.livejournal.com/3636.html
Requires:       libv4l = %{version}-%{release}

%description -n libv4l-devel
The libv4l-devel package contains libraries and header files for
developing applications that use libv4l.


%package -n     libdvbv5-devel
Summary:        Development files for libdvbv5
License:        GPLv2
Requires:       libdvbv5 = %{version}-%{release}

%description -n libdvbv5-devel
This package provides libraries and header files for developing
applications that use libdvbv5.


%prep
%autosetup -p1

%build
export CXXFLAGS="-std=c++14 $RPM_OPT_FLAGS"
%configure --disable-static --enable-libdvbv5 --enable-doxygen-man
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make_build
make doxygen-run


%install
%make_install

find %{buildroot} -name '*.la' -delete
rm -f %{buildroot}%{_libdir}/{v4l1compat.so,v4l2convert.so}
mkdir -p %{buildroot}%{_mandir}/man3/
cp -arv %{_builddir}/%{name}-%{version}/doxygen-doc/man/man3 %{buildroot}%{_mandir}/
rm %{buildroot}%{_mandir}/man3/_*3

%find_lang %{name}
%find_lang libdvbv5


%files -f %{name}.lang
%license COPYING
%doc README.md
%{_bindir}/cx18-ctl
%{_bindir}/cec*
%{_bindir}/dvb*
%{_bindir}/ir-ctl
%{_bindir}/ir-keytable
%{_bindir}/ivtv-ctl
%{_bindir}/media-ctl
%{_bindir}/rds-ctl
%{_bindir}/v4l2-ctl
%{_bindir}/v4l2-sysfs-path
%dir %{_sysconfdir}/rc_keymaps
%config(noreplace) %{_sysconfdir}/rc_maps.cfg
%{_udevrulesdir}/70-infrared.rules
%{_udevrulesdir}/../rc_keymaps/*
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%exclude %{_mandir}/man1/v4l2-compliance.1*

%files devel-tools
%doc README.md
%{_bindir}/decode_tm6000
%{_bindir}/v4l2-compliance
%{_sbindir}/v4l2-dbg
%{_mandir}/man1/v4l2-compliance.1*

%files -n qv4l2
%doc README.md
%{_bindir}/qv4l2
%{_bindir}/qvidcap
%{_datadir}/applications/qv4l2.desktop
%{_datadir}/applications/qvidcap.desktop
%{_datadir}/icons/hicolor/*/apps/qv4l2.*
%{_datadir}/icons/hicolor/*/apps/qvidcap.*
%{_mandir}/man1/qv4l2.1*
%{_mandir}/man1/qvidcap.1*

%files -n libv4l
%doc ChangeLog README.libv4l TODO
%license COPYING.libv4l COPYING
%{_libdir}/libv4l
%{_libdir}/libv4l*.so.*

%files -n libv4l-devel
%doc README.lib-multi-threading
%{_includedir}/libv4l*.h
%{_libdir}/libv4l*.so
%{_libdir}/pkgconfig/libv4l*.pc

%files -n libdvbv5 -f libdvbv5.lang
%license COPYING
%doc ChangeLog lib/libdvbv5/README
%{_libdir}/libdvbv5*.so.*

%files -n libdvbv5-devel
%{_includedir}/libdvbv5/*.h
%{_libdir}/libdvbv5*.so
%{_libdir}/pkgconfig/libdvbv5*.pc
%{_mandir}/man3/*.3*


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.24.1-4
- Rebuilt for loongarch release

* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 1.24.1-3
- Rebuilt for llvm 17.0.6

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.24.1-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 kianli <kianli@tencent.com> - 1.24.1-1
- Upgrade to 1.24.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.22.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.22.1-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 28 2022 cunshunxia <cunshunxia@tencent.com> - 1.22.1-1
- initial build
